package com.sun.org.apache.xalan.internal.xslt;

import java.io.Writer;
import java.io.OutputStream;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Document;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.parsers.SAXParser;
import org.xml.sax.XMLReader;
import javax.xml.transform.Transformer;
import javax.xml.transform.Source;
import org.w3c.dom.Node;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.transform.Templates;
import java.util.Properties;
import com.sun.org.apache.xml.internal.utils.WrappedRuntimeException;
import java.io.IOException;
import javax.xml.transform.dom.DOMResult;
import org.xml.sax.SAXNotSupportedException;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.ErrorHandler;
import javax.xml.transform.sax.SAXSource;
import org.xml.sax.helpers.XMLReaderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import org.xml.sax.SAXException;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.transform.sax.SAXResult;
import java.io.StringReader;
import javax.xml.transform.TransformerException;
import javax.xml.transform.sax.SAXTransformerFactory;
import java.io.FileOutputStream;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.dom.DOMSource;
import org.xml.sax.InputSource;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.stream.StreamSource;
import java.io.FileWriter;
import com.sun.org.apache.xalan.internal.Version;
import javax.xml.transform.URIResolver;
import org.xml.sax.EntityResolver;
import com.sun.org.apache.xalan.internal.utils.ConfigurationError;
import com.sun.org.apache.xalan.internal.utils.ObjectFactory;
import org.xml.sax.ContentHandler;
import javax.xml.transform.TransformerConfigurationException;
import java.util.Vector;
import javax.xml.transform.TransformerFactoryConfigurationError;
import com.sun.org.apache.xalan.internal.res.XSLMessages;
import com.sun.org.apache.xml.internal.utils.DefaultErrorHandler;
import javax.xml.transform.TransformerFactory;
import com.sun.org.apache.xalan.internal.utils.SecuritySupport;
import java.io.PrintWriter;
import java.util.ResourceBundle;

public class Process
{
    public Process() {
    }
    
    protected static void printArgOptions(ResourceBundle resbundle) {
        System.out.println(resbundle.getString("xslProc_option"));
        System.out.println("\n\t\t\t" + resbundle.getString("xslProc_common_options") + "\n");
        System.out.println(resbundle.getString("optionXSLTC"));
        System.out.println(resbundle.getString("optionIN"));
        System.out.println(resbundle.getString("optionXSL"));
        System.out.println(resbundle.getString("optionOUT"));
        System.out.println(resbundle.getString("optionV"));
        System.out.println(resbundle.getString("optionEDUMP"));
        System.out.println(resbundle.getString("optionXML"));
        System.out.println(resbundle.getString("optionTEXT"));
        System.out.println(resbundle.getString("optionHTML"));
        System.out.println(resbundle.getString("optionPARAM"));
        System.out.println(resbundle.getString("optionMEDIA"));
        System.out.println(resbundle.getString("optionFLAVOR"));
        System.out.println(resbundle.getString("optionDIAG"));
        System.out.println(resbundle.getString("optionURIRESOLVER"));
        System.out.println(resbundle.getString("optionENTITYRESOLVER"));
        waitForReturnKey(resbundle);
        System.out.println(resbundle.getString("optionCONTENTHANDLER"));
        System.out.println(resbundle.getString("optionSECUREPROCESSING"));
        System.out.println("\n\t\t\t" + resbundle.getString("xslProc_xsltc_options") + "\n");
        System.out.println(resbundle.getString("optionXO"));
        waitForReturnKey(resbundle);
        System.out.println(resbundle.getString("optionXD"));
        System.out.println(resbundle.getString("optionXJ"));
        System.out.println(resbundle.getString("optionXP"));
        System.out.println(resbundle.getString("optionXN"));
        System.out.println(resbundle.getString("optionXX"));
        System.out.println(resbundle.getString("optionXT"));
    }
    
    public static void _main(String[] argv) {
        boolean doStackDumpOnError = false;
        boolean setQuietMode = false;
        boolean doDiag = false;
        String msg = null;
        boolean isSecureProcessing = false;
        PrintWriter dumpWriter;
        PrintWriter diagnosticsWriter = dumpWriter = new PrintWriter(System.err, true);
        ResourceBundle resbundle = SecuritySupport.getResourceBundle("com.sun.org.apache.xalan.internal.res.XSLTErrorResources");
        String flavor = "s2s";
        if (argv.length < 1) {
            printArgOptions(resbundle);
            return;
        }
        boolean useXSLTC = true;
        for (int i = 0; i < argv.length; ++i) {
            if ("-XSLTC".equalsIgnoreCase(argv[i])) {
                useXSLTC = true;
            }
        }
        if (useXSLTC) {
            String key = "javax.xml.transform.TransformerFactory";
            String value = "com.sun.org.apache.xalan.internal.xsltc.trax.TransformerFactoryImpl";
            Properties props = System.getProperties();
            props.put(key, value);
            System.setProperties(props);
        }
        TransformerFactory tfactory;
        try {
            tfactory = TransformerFactory.newInstance();
            tfactory.setErrorListener(new DefaultErrorHandler());
        }
        catch (TransformerFactoryConfigurationError pfe) {
            pfe.printStackTrace(dumpWriter);
            msg = XSLMessages.createMessage("ER_NOT_SUCCESSFUL", (Object[])null);
            diagnosticsWriter.println(msg);
            tfactory = null;
            doExit(msg);
        }
        boolean formatOutput = false;
        boolean useSourceLocation = false;
        String inFileName = null;
        String outFileName = null;
        String dumpFileName = null;
        String xslFileName = null;
        String treedumpFileName = null;
        String outputType = null;
        String media = null;
        Vector<String> params = new Vector();
        boolean quietConflictWarnings = false;
        URIResolver uriResolver = null;
        EntityResolver entityResolver = null;
        ContentHandler contentHandler = null;
        int recursionLimit = -1;
        for (int j = 0; j < argv.length; ++j) {
            if (!"-XSLTC".equalsIgnoreCase(argv[j])) {
                if ("-INDENT".equalsIgnoreCase(argv[j])) {
                    if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                        int indentAmount = Integer.parseInt(argv[++j]);
                    }
                }
                else if ("-IN".equalsIgnoreCase(argv[j])) {
                    if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                        inFileName = argv[++j];
                    }
                    else {
                        System.err.println(XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-IN" }));
                    }
                }
                else if ("-MEDIA".equalsIgnoreCase(argv[j])) {
                    if (j + 1 < argv.length) {
                        media = argv[++j];
                    }
                    else {
                        System.err.println(XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-MEDIA" }));
                    }
                }
                else if ("-OUT".equalsIgnoreCase(argv[j])) {
                    if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                        outFileName = argv[++j];
                    }
                    else {
                        System.err.println(XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-OUT" }));
                    }
                }
                else if ("-XSL".equalsIgnoreCase(argv[j])) {
                    if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                        xslFileName = argv[++j];
                    }
                    else {
                        System.err.println(XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-XSL" }));
                    }
                }
                else if ("-FLAVOR".equalsIgnoreCase(argv[j])) {
                    if (j + 1 < argv.length) {
                        flavor = argv[++j];
                    }
                    else {
                        System.err.println(XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-FLAVOR" }));
                    }
                }
                else if ("-PARAM".equalsIgnoreCase(argv[j])) {
                    if (j + 2 < argv.length) {
                        String name = argv[++j];
                        params.addElement(name);
                        String expression = argv[++j];
                        params.addElement(expression);
                    }
                    else {
                        System.err.println(XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-PARAM" }));
                    }
                }
                else if (!"-E".equalsIgnoreCase(argv[j])) {
                    if ("-V".equalsIgnoreCase(argv[j])) {
                        diagnosticsWriter.println(resbundle.getString("version") + Version.getVersion() + ", " + resbundle.getString("version2"));
                    }
                    else if ("-Q".equalsIgnoreCase(argv[j])) {
                        setQuietMode = true;
                    }
                    else if ("-DIAG".equalsIgnoreCase(argv[j])) {
                        doDiag = true;
                    }
                    else if ("-XML".equalsIgnoreCase(argv[j])) {
                        outputType = "xml";
                    }
                    else if ("-TEXT".equalsIgnoreCase(argv[j])) {
                        outputType = "text";
                    }
                    else if ("-HTML".equalsIgnoreCase(argv[j])) {
                        outputType = "html";
                    }
                    else if ("-EDUMP".equalsIgnoreCase(argv[j])) {
                        doStackDumpOnError = true;
                        if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                            dumpFileName = argv[++j];
                        }
                    }
                    else if ("-URIRESOLVER".equalsIgnoreCase(argv[j])) {
                        if (j + 1 < argv.length) {
                            try {
                                uriResolver = (URIResolver)ObjectFactory.newInstance(argv[++j], true);
                                tfactory.setURIResolver(uriResolver);
                            }
                            catch (ConfigurationError cnfe) {
                                msg = XSLMessages.createMessage("ER_CLASS_NOT_FOUND_FOR_OPTION", new Object[] { "-URIResolver" });
                                System.err.println(msg);
                                doExit(msg);
                            }
                        }
                        else {
                            msg = XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-URIResolver" });
                            System.err.println(msg);
                            doExit(msg);
                        }
                    }
                    else if ("-ENTITYRESOLVER".equalsIgnoreCase(argv[j])) {
                        if (j + 1 < argv.length) {
                            try {
                                entityResolver = (EntityResolver)ObjectFactory.newInstance(argv[++j], true);
                            }
                            catch (ConfigurationError cnfe) {
                                msg = XSLMessages.createMessage("ER_CLASS_NOT_FOUND_FOR_OPTION", new Object[] { "-EntityResolver" });
                                System.err.println(msg);
                                doExit(msg);
                            }
                        }
                        else {
                            msg = XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-EntityResolver" });
                            System.err.println(msg);
                            doExit(msg);
                        }
                    }
                    else if ("-CONTENTHANDLER".equalsIgnoreCase(argv[j])) {
                        if (j + 1 < argv.length) {
                            try {
                                contentHandler = (ContentHandler)ObjectFactory.newInstance(argv[++j], true);
                            }
                            catch (ConfigurationError cnfe) {
                                msg = XSLMessages.createMessage("ER_CLASS_NOT_FOUND_FOR_OPTION", new Object[] { "-ContentHandler" });
                                System.err.println(msg);
                                doExit(msg);
                            }
                        }
                        else {
                            msg = XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-ContentHandler" });
                            System.err.println(msg);
                            doExit(msg);
                        }
                    }
                    else if ("-XO".equalsIgnoreCase(argv[j])) {
                        if (useXSLTC) {
                            if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                                tfactory.setAttribute("generate-translet", "true");
                                tfactory.setAttribute("translet-name", argv[++j]);
                            }
                            else {
                                tfactory.setAttribute("generate-translet", "true");
                            }
                        }
                        else {
                            if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                                ++j;
                            }
                            printInvalidXalanOption("-XO");
                        }
                    }
                    else if ("-XD".equalsIgnoreCase(argv[j])) {
                        if (useXSLTC) {
                            if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                                tfactory.setAttribute("destination-directory", argv[++j]);
                            }
                            else {
                                System.err.println(XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-XD" }));
                            }
                        }
                        else {
                            if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                                ++j;
                            }
                            printInvalidXalanOption("-XD");
                        }
                    }
                    else if ("-XJ".equalsIgnoreCase(argv[j])) {
                        if (useXSLTC) {
                            if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                                tfactory.setAttribute("generate-translet", "true");
                                tfactory.setAttribute("jar-name", argv[++j]);
                            }
                            else {
                                System.err.println(XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-XJ" }));
                            }
                        }
                        else {
                            if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                                ++j;
                            }
                            printInvalidXalanOption("-XJ");
                        }
                    }
                    else if ("-XP".equalsIgnoreCase(argv[j])) {
                        if (useXSLTC) {
                            if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                                tfactory.setAttribute("package-name", argv[++j]);
                            }
                            else {
                                System.err.println(XSLMessages.createMessage("ER_MISSING_ARG_FOR_OPTION", new Object[] { "-XP" }));
                            }
                        }
                        else {
                            if (j + 1 < argv.length && argv[j + 1].charAt(0) != '-') {
                                ++j;
                            }
                            printInvalidXalanOption("-XP");
                        }
                    }
                    else if ("-XN".equalsIgnoreCase(argv[j])) {
                        if (useXSLTC) {
                            tfactory.setAttribute("enable-inlining", "true");
                        }
                        else {
                            printInvalidXalanOption("-XN");
                        }
                    }
                    else if ("-XX".equalsIgnoreCase(argv[j])) {
                        if (useXSLTC) {
                            tfactory.setAttribute("debug", "true");
                        }
                        else {
                            printInvalidXalanOption("-XX");
                        }
                    }
                    else if ("-XT".equalsIgnoreCase(argv[j])) {
                        if (useXSLTC) {
                            tfactory.setAttribute("auto-translet", "true");
                        }
                        else {
                            printInvalidXalanOption("-XT");
                        }
                    }
                    else if ("-SECURE".equalsIgnoreCase(argv[j])) {
                        isSecureProcessing = true;
                        try {
                            tfactory.setFeature("http://javax.xml.XMLConstants/feature/secure-processing", true);
                        }
                        catch (TransformerConfigurationException ex5) {}
                    }
                    else {
                        System.err.println(XSLMessages.createMessage("ER_INVALID_OPTION", new Object[] { argv[j] }));
                    }
                }
            }
        }
        if (inFileName == null && xslFileName == null) {
            msg = resbundle.getString("xslProc_no_input");
            System.err.println(msg);
            doExit(msg);
        }
        try {
            long start = System.currentTimeMillis();
            if (null != dumpFileName) {
                dumpWriter = new PrintWriter(new FileWriter(dumpFileName));
            }
            Templates stylesheet = null;
            if (null != xslFileName) {
                if (flavor.equals("d2d")) {
                    DocumentBuilderFactory dfactory = DocumentBuilderFactory.newInstance();
                    dfactory.setNamespaceAware(true);
                    if (isSecureProcessing) {
                        try {
                            dfactory.setFeature("http://javax.xml.XMLConstants/feature/secure-processing", true);
                        }
                        catch (ParserConfigurationException ex6) {}
                    }
                    DocumentBuilder docBuilder = dfactory.newDocumentBuilder();
                    Node xslDOM = docBuilder.parse(new InputSource(xslFileName));
                    stylesheet = tfactory.newTemplates(new DOMSource(xslDOM, xslFileName));
                }
                else {
                    stylesheet = tfactory.newTemplates(new StreamSource(xslFileName));
                }
            }
            StreamResult strResult;
            if (null != outFileName) {
                strResult = new StreamResult(new FileOutputStream(outFileName));
                strResult.setSystemId(outFileName);
            }
            else {
                strResult = new StreamResult(System.out);
            }
            SAXTransformerFactory stf = (SAXTransformerFactory)tfactory;
            if (null == stylesheet) {
                Source source = stf.getAssociatedStylesheet(new StreamSource(inFileName), media, null, null);
                if (null != source) {
                    stylesheet = tfactory.newTemplates(source);
                }
                else {
                    if (null != media) {
                        throw new TransformerException(XSLMessages.createMessage("ER_NO_STYLESHEET_IN_MEDIA", new Object[] { inFileName, media }));
                    }
                    throw new TransformerException(XSLMessages.createMessage("ER_NO_STYLESHEET_PI", new Object[] { inFileName }));
                }
            }
            if (null != stylesheet) {
                Transformer transformer = flavor.equals("th") ? null : stylesheet.newTransformer();
                transformer.setErrorListener(new DefaultErrorHandler());
                if (null != outputType) {
                    transformer.setOutputProperty("method", outputType);
                }
                for (int nParams = params.size(), k = 0; k < nParams; k += 2) {
                    transformer.setParameter((String)params.elementAt(k), (Object)params.elementAt(k + 1));
                }
                if (uriResolver != null) {
                    transformer.setURIResolver(uriResolver);
                }
                if (null != inFileName) {
                    if (flavor.equals("d2d")) {
                        DocumentBuilderFactory dfactory2 = DocumentBuilderFactory.newInstance();
                        dfactory2.setCoalescing(true);
                        dfactory2.setNamespaceAware(true);
                        if (isSecureProcessing) {
                            try {
                                dfactory2.setFeature("http://javax.xml.XMLConstants/feature/secure-processing", true);
                            }
                            catch (ParserConfigurationException ex12) {}
                        }
                        DocumentBuilder docBuilder2 = dfactory2.newDocumentBuilder();
                        if (entityResolver != null) {
                            docBuilder2.setEntityResolver(entityResolver);
                        }
                        Node xmlDoc = docBuilder2.parse(new InputSource(inFileName));
                        Document doc = docBuilder2.newDocument();
                        DocumentFragment outNode = doc.createDocumentFragment();
                        transformer.transform(new DOMSource(xmlDoc, inFileName), new DOMResult(outNode));
                        Transformer serializer = stf.newTransformer();
                        serializer.setErrorListener(new DefaultErrorHandler());
                        Properties serializationProps = stylesheet.getOutputProperties();
                        serializer.setOutputProperties(serializationProps);
                        if (contentHandler != null) {
                            SAXResult result3 = new SAXResult(contentHandler);
                            serializer.transform(new DOMSource(outNode), result3);
                        }
                        else {
                            serializer.transform(new DOMSource(outNode), strResult);
                        }
                    }
                    else if (flavor.equals("th")) {
                        for (int k = 0; k < 1; ++k) {
                            XMLReader reader3 = null;
                            try {
                                SAXParserFactory factory2 = SAXParserFactory.newInstance();
                                factory2.setNamespaceAware(true);
                                if (isSecureProcessing) {
                                    try {
                                        factory2.setFeature("http://javax.xml.XMLConstants/feature/secure-processing", true);
                                    }
                                    catch (SAXException ex8) {}
                                }
                                SAXParser jaxpParser2 = factory2.newSAXParser();
                                reader3 = jaxpParser2.getXMLReader();
                            }
                            catch (ParserConfigurationException ex3) {
                                throw new SAXException(ex3);
                            }
                            catch (FactoryConfigurationError ex4) {
                                throw new SAXException(ex4.toString());
                            }
                            catch (NoSuchMethodError noSuchMethodError2) {}
                            catch (AbstractMethodError abstractMethodError2) {}
                            if (null == reader3) {
                                reader3 = XMLReaderFactory.createXMLReader();
                            }
                            TransformerHandler th = stf.newTransformerHandler(stylesheet);
                            reader3.setContentHandler(th);
                            reader3.setDTDHandler(th);
                            if ((th instanceof ErrorHandler)) {
                                reader3.setErrorHandler((ErrorHandler)th);
                            }
                            try {
                                reader3.setProperty("http://xml.org/sax/properties/lexical-handler", th);
                            }
                            catch (SAXNotRecognizedException ex9) {}
                            catch (SAXNotSupportedException ex10) {}
                            try {
                                reader3.setFeature("http://xml.org/sax/features/namespace-prefixes", true);
                            }
                            catch (SAXException ex11) {}
                            th.setResult(strResult);
                            reader3.parse(new InputSource(inFileName));
                        }
                    }
                    else if (entityResolver != null) {
                        XMLReader reader2 = null;
                        try {
                            SAXParserFactory factory = SAXParserFactory.newInstance();
                            factory.setNamespaceAware(true);
                            if (isSecureProcessing) {
                                try {
                                    factory.setFeature("http://javax.xml.XMLConstants/feature/secure-processing", true);
                                }
                                catch (SAXException ex7) {}
                            }
                            SAXParser jaxpParser = factory.newSAXParser();
                            reader2 = jaxpParser.getXMLReader();
                        }
                        catch (ParserConfigurationException ex) {
                            throw new SAXException(ex);
                        }
                        catch (FactoryConfigurationError ex2) {
                            throw new SAXException(ex2.toString());
                        }
                        catch (NoSuchMethodError noSuchMethodError) {}
                        catch (AbstractMethodError abstractMethodError) {}
                        if (null == reader2) {
                            reader2 = XMLReaderFactory.createXMLReader();
                        }
                        reader2.setEntityResolver(entityResolver);
                        if (contentHandler != null) {
                            SAXResult result2 = new SAXResult(contentHandler);
                            transformer.transform(new SAXSource(reader2, new InputSource(inFileName)), result2);
                        }
                        else {
                            transformer.transform(new SAXSource(reader2, new InputSource(inFileName)), strResult);
                        }
                    }
                    else if (contentHandler != null) {
                        SAXResult result = new SAXResult(contentHandler);
                        transformer.transform(new StreamSource(inFileName), result);
                    }
                    else {
                        transformer.transform(new StreamSource(inFileName), strResult);
                    }
                }
                else {
                    StringReader reader = new StringReader("<?xml version=\"1.0\"?> <doc/>");
                    transformer.transform(new StreamSource(reader), strResult);
                }
            }
            else {
                msg = XSLMessages.createMessage("ER_NOT_SUCCESSFUL", (Object[])null);
                diagnosticsWriter.println(msg);
                doExit(msg);
            }
            if (null != outFileName && strResult != null) {
                OutputStream out = strResult.getOutputStream();
                Writer writer = strResult.getWriter();
                try {
                    if (out != null) {
                        out.close();
                    }
                    if (writer != null) {
                        writer.close();
                    }
                }
                catch (IOException ex13) {}
            }
            long stop = System.currentTimeMillis();
            long millisecondsDuration = stop - start;
            if (doDiag) {
                Object[] msgArgs = { inFileName, xslFileName, new Long(millisecondsDuration) };
                msg = XSLMessages.createMessage("diagTiming", msgArgs);
                diagnosticsWriter.println('\n');
                diagnosticsWriter.println(msg);
            }
        }
        catch (Throwable throwable) {
            while (throwable instanceof WrappedRuntimeException) {
                throwable = ((WrappedRuntimeException)throwable).getException();
            }
            if (throwable instanceof NullPointerException || throwable instanceof ClassCastException) {
                doStackDumpOnError = true;
            }
            diagnosticsWriter.println();
            if (doStackDumpOnError) {
                throwable.printStackTrace(dumpWriter);
            }
            else {
                DefaultErrorHandler.printLocation(diagnosticsWriter, throwable);
                diagnosticsWriter.println(XSLMessages.createMessage("ER_XSLT_ERROR", (Object[])null) + " (" + throwable.getClass().getName() + "): " + throwable.getMessage());
            }
            if (null != dumpFileName) {
                dumpWriter.close();
            }
            doExit(throwable.getMessage());
        }
        Label_3332: {
            if (null != dumpFileName) {
                dumpWriter.close();
                break Label_3332;
            }
            break Label_3332;
        }
    }
    
    static void doExit(String msg) {
        throw new RuntimeException(msg);
    }
    
    private static void waitForReturnKey(ResourceBundle resbundle) {
        System.out.println(resbundle.getString("xslProc_return_to_continue"));
        try {
            while (System.in.read() != 10) {}
        }
        catch (IOException ex) {}
    }
    
    private static void printInvalidXSLTCOption(String option) {
        System.err.println(XSLMessages.createMessage("xslProc_invalid_xsltc_option", new Object[] { option }));
    }
    
    private static void printInvalidXalanOption(String option) {
        System.err.println(XSLMessages.createMessage("xslProc_invalid_xalan_option", new Object[] { option }));
    }
}
